---
id: 메모리주소
title: 1) 메모리 주소
---
## 16진수
**16진수**(Hexadecimal)는 0 ~ 9 까지는 0 ~ 9로, 10 ~ 15 까지는 a ~ f로 표현한다.

16진수를 사용할 땐 모든 수 앞에 0x를 붙인다.

---


## 10진수를 16진수로 바꾸기
![decimal to hexadecimal](https://cphinf.pstatic.net/mooc/20170807_218/1502072784893AgAug_PNG/5.4_-01.png?type=w760)

---


## 16진수의 유용성
컴퓨터 과학에선 숫자를 10진수나 12지수 대신 16진수로 표현하는 경우가 많다.

16진수로 표현하면 2진수로 표현했을 때 보다 훨씬 간단하고,

8개의 비트가 모인 바이트 단위로 정보를 표현하는 컴퓨터에게 있어 2개의 16진수를 1바이트의 2진수로 변환되기 때문에 정보를 표현하기에 매우 유용하기 떄문이다.

---

## 메모리 주소
C언어에서 변수의 메모리상 주소를 받기 위해 `&`이라는 연산자를 사용할 수 있으며,
이를 받기위해 `%p`라는 형식 지정자를 쓸 수 있다.
```c
#include <stdio.h>

int main(void)
{
    int n = 50;
    printf("%p\n", &n);
}
```
`*`를 사용하면 그 메모리 주소에 있는 실제 값을 얻을 수 있다.
```c
#include <stdio.h>

int main(void)
{
    int n = 50;
    printf("%i\n", *&n);
}
```


:::note
written by [Caution-Sun](https://github.com/Caution-Sun)
:::
