---
id: 파일읽기
title: 9) 파일 읽기
---

## 파일 읽기

아래의 코드는 파일의 내용을 읽어서 파일의 형식이 JPEG 이미지인지를 검사하는 프로그램이다.

```c
#include <stdio.h>

int main(int argc, char *argv[])
{
    if (argc != 2)
    {
        return 1;
    }

    FILE *file = fopen(argv[1], "r");

    if (file == NULL)
    {
        return 1;
    }
 
   unsigned char bytes[3];
    fread(bytes, 3, 1, file);

    if (bytes[0] == 0xff && bytes[1] == 0xd8 && bytes[2] == 0xff)
    {
        printf("Maybe\n");
    }
    else
    {
        printf("No\n");
    }
    fclose(file);
}
```
main 함수는 **파일의 이름**을 입력받는다.

입력받은 파일명(argv[1])을 **읽기(r)** 모드로 불러온다.

그 후 크기가 3인 문자 배열을 만들고, `fread` 함수를 이용해서 파일에서 첫 3바이트를 읽어온다.

fread 함수의 각 인자는 **(배열, 읽을 바이트 수, 읽을 횟수, 읽을 파일)**을 의미합니다.

마지막으로 읽어들인 각 바이트가 각각 **0xFF, 0xD8, 0xFF** 인지를 확인한다.

이는 JPEG 형식의 파일을 정의할 때 만든 약속으로, JPEG 파일의 시작점에 꼭 포함되어 있어야 한다.

따라서 이를 검사하면 JPEG 파일인지를 확인할 수 있다.

---

:::note
written by [Caution-Sun](https://github.com/Caution-Sun)
:::
