---
id: 스택큐
title: 9) 스택, 큐, 딕셔너리
---

세 가지 대표적인 자료 구조를 알아봅시다.

## 큐

`큐`는 메모리 구조에서 살펴봤듯이 값이 **아래로 쌓이는 구조**입니다.

값을 넣고 뺄 때 **‘선입 선출’ 또는 ‘FIFO’**라는 방식을 따르게 됩니다. 가장 먼저 들어온 값이 가장 먼저 나가는 것이죠.

은행에서 줄을 설 때 가장 먼저 줄을 선 사람이 가장 먼저 업무를 처리하게 되는 것과 동일합니다.

배열이나 연결 리스트를 통해 구현 가능합니다.

![큐](https://blog.kakaocdn.net/dn/oDQle/btqyQL30Bq4/Tiw0oIqWsrDb19ukJVvLD0/img.jpg)

## 스택

반면 `스택`은 역시 메모리 구조에서 살펴봤듯이 값이 **위로 쌓이는 구조**입니다.

따라서 값을 넣고 뺄 때 **‘후입 선출’ 또는 ‘LIFO’**라는 방식을 따르게 됩니다. 가장 나중에 들어온 값이 가장 먼저 나가는 것이죠.

뷔페에서 접시를 쌓아 뒀을 때 사람들이 가장 위에 있는(즉, 가장 나중에 쌓인) 접시를 가장 먼저 들고 가는 것과 동일합니다.

역시 배열이나 연결 리스트를 통해 구현 가능합니다.

![스택](https://media.vlpt.us/images/jangwonyoon/post/e64387f5-8394-498c-b37f-3f3570c42900/%E1%84%89%E1%85%B3%E1%84%8F%E1%85%B3%E1%84%85%E1%85%B5%E1%86%AB%E1%84%89%E1%85%A3%E1%86%BA%202020-03-19%20%E1%84%8B%E1%85%A9%E1%84%92%E1%85%AE%203.01.10.png)

## 딕셔너리

`딕셔너리`는 **‘키’와 ‘값’**이라는 요소로 이루어져 있습니다.

‘키’에 해당하는 ‘값’을 저장하고 읽어오는 것이죠. 마치 대학교에서 ‘학번’에 따라서 ‘학생’이 결정되는 것과 동일합니다.

일반적인 의미에서 **‘해시 테이블’**과 동일한 개념이라고도 볼 수 있습니다.

‘키’를 어떻게 정의할 것인지가 중요합니다.

![딕셔너리](https://lh3.googleusercontent.com/proxy/QrxMDA91lQltEu10Z3DRNdHVCFlwtexR1335J-PBySnqI8cGIjk1iW72mXUA5GXEyvz35qoyXYj93cvcDF-ACM9Fq0rOeEE31e8XhQAK01srpoqkGGAe0dWrMofXSf3Ouu3f0gaC8djmFUGgrKEUhcdz47yBLxs6HmhEwmySbD55ySKcKh1UuFrz4AerJAMqrsVUw4J0AVfeLOc_76olkD5rjhYspCgpd4OBwg)

:::note
written by [CaesiumY](https://github.com/CaesiumY)
:::
